diff -pruN 1.3.610-1/debian/changelog 1.3.610-2/debian/changelog
--- 1.3.610-1/debian/changelog	2020-11-17 14:25:51.000000000 +0000
+++ 1.3.610-2/debian/changelog	2020-12-08 23:10:47.000000000 +0000
@@ -1,3 +1,15 @@
+core-async-clojure (1.3.610-2) unstable; urgency=medium
+
+  * Team upload.
+  * d/rules: build using leiningen. (Closes: #976415)
+  * d/control: add a versioned dependency on tools-analyzer-jvm.
+  * d/control: Standards-Version update to 4.5.1. No changes required.
+  * d/patches: add 0002 to revert upstream regression in testsuite.
+  * d/tests: fix classpath issue.
+  * Add classpath to binary jar.
+
+ -- Louis-Philippe Véronneau <pollo@debian.org>  Tue, 08 Dec 2020 18:10:47 -0500
+
 core-async-clojure (1.3.610-1) unstable; urgency=medium
 
   * Team upload.
diff -pruN 1.3.610-1/debian/control 1.3.610-2/debian/control
--- 1.3.610-1/debian/control	2020-11-17 14:22:28.000000000 +0000
+++ 1.3.610-2/debian/control	2020-12-08 21:15:03.000000000 +0000
@@ -6,10 +6,13 @@ Uploaders: Apollon Oikonomopoulos <apoik
 Build-Depends: debhelper-compat (= 13),
                javahelper,
                maven-repo-helper,
-               clojure,
                default-jdk,
-               libtools-analyzer-jvm-clojure
-Standards-Version: 4.5.0
+               libclojure-java,
+               libtools-analyzer-jvm-clojure (>=1.1.0),
+               libnrepl-clojure <!nocheck>,
+               libcomplete-clojure <!nocheck>,
+               leiningen,
+Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/clojure-team/core-async-clojure.git
 Vcs-Browser: https://salsa.debian.org/clojure-team/core-async-clojure
 Homepage: https://github.com/clojure/core.async
@@ -17,7 +20,10 @@ Rules-Requires-Root: no
 
 Package: libcore-async-clojure
 Architecture: all
-Depends: ${java:Depends}, ${misc:Depends}
+Depends: ${java:Depends},
+         ${misc:Depends},
+         libclojure-java,
+         libtools-analyzer-jvm-clojure (>=1.1.0),
 Recommends: ${java:Recommends}
 Description: asynchronous programming using channels for Clojure
  core.async is a Clojure library designed to provide facilities for async
diff -pruN 1.3.610-1/debian/libcore-async-clojure.classpath 1.3.610-2/debian/libcore-async-clojure.classpath
--- 1.3.610-1/debian/libcore-async-clojure.classpath	1970-01-01 00:00:00.000000000 +0000
+++ 1.3.610-2/debian/libcore-async-clojure.classpath	2020-12-08 22:56:24.000000000 +0000
@@ -0,0 +1 @@
+usr/share/java/core.async.jar usr/share/java/clojure.jar usr/share/java/tools.analyzer.jvm
diff -pruN 1.3.610-1/debian/libcore-async-clojure.jlibs 1.3.610-2/debian/libcore-async-clojure.jlibs
--- 1.3.610-1/debian/libcore-async-clojure.jlibs	2020-11-13 23:45:54.000000000 +0000
+++ 1.3.610-2/debian/libcore-async-clojure.jlibs	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-core.async.jar
diff -pruN 1.3.610-1/debian/libcore-async-clojure.poms 1.3.610-2/debian/libcore-async-clojure.poms
--- 1.3.610-1/debian/libcore-async-clojure.poms	2020-11-14 00:41:28.000000000 +0000
+++ 1.3.610-2/debian/libcore-async-clojure.poms	2020-12-07 17:28:22.000000000 +0000
@@ -1 +1 @@
-pom.xml --artifact=core.async.jar --usj-name=core.async
+debian/pom.xml --artifact=target/core.async.jar --usj-name=core.async
diff -pruN 1.3.610-1/debian/patches/0001_Lein_Local.patch 1.3.610-2/debian/patches/0001_Lein_Local.patch
--- 1.3.610-1/debian/patches/0001_Lein_Local.patch	1970-01-01 00:00:00.000000000 +0000
+++ 1.3.610-2/debian/patches/0001_Lein_Local.patch	2020-12-08 22:05:19.000000000 +0000
@@ -0,0 +1,37 @@
+Patch project.clj so we can build using lein locally.
+Index: core-async-clojure/project.clj
+===================================================================
+--- core-async-clojure.orig/project.clj
++++ core-async-clojure/project.clj
+@@ -1,12 +1,10 @@
+-(defproject org.clojure/core.async "0.1.0-SNAPSHOT"
++(defproject org.clojure/core.async "1.3.610"
+   :description "Facilities for async programming and communication in Clojure"
+   :url "https://github.com/clojure/core.async"
+   :license {:name "Eclipse Public License"
+             :url "http://www.eclipse.org/legal/epl-v10.html"}
+-  :parent [org.clojure/pom.contrib "1.0.0"]
+-  :dependencies [[org.clojure/clojure "1.9.0"]
+-                 [org.clojure/tools.analyzer.jvm "1.0.0"]
+-                 [org.clojure/clojurescript "1.10.597" :scope "provided"]]
++  :dependencies [[org.clojure/clojure "1.10.x"]
++                 [org.clojure/tools.analyzer.jvm "debian"]]
+   :global-vars {*warn-on-reflection* true}
+   :source-paths ["src/main/clojure"]
+   :test-paths ["src/test/clojure"]
+@@ -14,8 +12,6 @@
+   :java-source-paths ["src/main/java"]
+   :profiles {:dev {:source-paths ["examples"]}}
+ 
+-  :plugins [[lein-cljsbuild "1.1.7"]]
+-
+   :clean-targets ["tests.js" "tests.js.map"
+                   "out" "out-simp" "out-simp-node"
+                   "out-adv" "out-adv-node"]
+@@ -59,4 +55,5 @@
+                 :pretty-print false
+                 :output-dir "out-adv-node"
+                 :output-to "tests.js"
+-                :source-map "tests.js.map"}}]})
++                :source-map "tests.js.map"}}]}
++  :local-repo "debian/maven-repo")
diff -pruN 1.3.610-1/debian/patches/0002_Fix_Test_Timing.patch 1.3.610-2/debian/patches/0002_Fix_Test_Timing.patch
--- 1.3.610-1/debian/patches/0002_Fix_Test_Timing.patch	1970-01-01 00:00:00.000000000 +0000
+++ 1.3.610-2/debian/patches/0002_Fix_Test_Timing.patch	2020-12-08 22:08:35.000000000 +0000
@@ -0,0 +1,42 @@
+Revert upstream commit 094d239e0261263de3799bb6bd1cc33f06833d8b "make test less
+timing dependent", as it seems to intermittently create the following
+regression:
+
+  lein test :only clojure.core.async-test/ops-tests
+
+  FAIL in (ops-tests) (async_test.clj:304)
+  mult
+  expected: (= nil (a/poll! t-1))
+    actual: (not (= nil 2))
+
+  lein test :only clojure.core.async-test/ops-tests
+
+  FAIL in (ops-tests) (async_test.clj:305)
+  mult
+  expected: (= 1 (<!! t-2))
+    actual: (not (= 1 2))
+
+  lein test :only clojure.core.async-test/ops-tests
+
+  FAIL in (ops-tests) (async_test.clj:306)
+  mult
+  expected: (= 2 (<!! t-1))
+    actual: (not (= 2 3))
+Index: core-async-clojure/src/test/clojure/clojure/core/async_test.clj
+===================================================================
+--- core-async-clojure.orig/src/test/clojure/clojure/core/async_test.clj
++++ core-async-clojure/src/test/clojure/clojure/core/async_test.clj
+@@ -300,10 +300,10 @@
+       (tap m t-2)
+       (tap m t-3)
+       (close! t-3)
+-      (is (= 1 (<!! t-1)))
++      (is (= 1 (a/poll! t-1)))
+       (is (= nil (a/poll! t-1))) ;; t-2 hasn't taken yet
+-      (is (= 1 (<!! t-2)))
+-      (is (= 2 (<!! t-1))) ;; now available
++      (is (= 1 (a/poll! t-2)))
++      (is (= 2 (a/poll! t-1))) ;; now available
+       (is (= nil (a/poll! t-1)))))
+ 
+   (testing "mix"
diff -pruN 1.3.610-1/debian/patches/series 1.3.610-2/debian/patches/series
--- 1.3.610-1/debian/patches/series	1970-01-01 00:00:00.000000000 +0000
+++ 1.3.610-2/debian/patches/series	2020-12-08 22:09:49.000000000 +0000
@@ -0,0 +1,2 @@
+0001_Lein_Local.patch
+0002_Fix_Test_Timing.patch
diff -pruN 1.3.610-1/debian/pom.xml 1.3.610-2/debian/pom.xml
--- 1.3.610-1/debian/pom.xml	1970-01-01 00:00:00.000000000 +0000
+++ 1.3.610-2/debian/pom.xml	2020-12-07 17:31:42.000000000 +0000
@@ -0,0 +1,98 @@
+<?xml version="1.0" encoding="UTF-8"?><project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
+  <modelVersion>4.0.0</modelVersion>
+  <groupId>org.clojure</groupId>
+  <artifactId>core.async</artifactId>
+  <packaging>jar</packaging>
+  <version>1.3.610</version>
+  <name>core.async</name>
+  <description>Facilities for async programming and communication in Clojure</description>
+  <url>https://github.com/clojure/core.async</url>
+  <licenses>
+    <license>
+      <name>Eclipse Public License</name>
+      <url>http://www.eclipse.org/legal/epl-v10.html</url>
+    </license>
+  </licenses>
+  <scm>
+    <tag>9454d6bb09b26eb34f097de2a27883adee44a7f7</tag>
+  </scm>
+  <build>
+    <sourceDirectory>src/main/clojure</sourceDirectory>
+    <testSourceDirectory>src/test/clojure</testSourceDirectory>
+    <resources>
+      <resource>
+        <directory>resources</directory>
+      </resource>
+    </resources>
+    <testResources>
+      <testResource>
+        <directory>resources</directory>
+      </testResource>
+    </testResources>
+    <directory>target</directory>
+    <outputDirectory>target/classes</outputDirectory>
+    <plugins>
+      <plugin>
+        <groupId>org.codehaus.mojo</groupId>
+        <artifactId>build-helper-maven-plugin</artifactId>
+        <version>1.7</version>
+        <executions>
+          <execution>
+            <id>add-source</id>
+            <phase>generate-sources</phase>
+            <goals>
+              <goal>add-source</goal>
+            </goals>
+            <configuration>
+              <sources>
+                <source>src/main/java</source>
+              </sources>
+            </configuration>
+          </execution>
+        </executions>
+      </plugin>
+    </plugins>
+  </build>
+  <repositories>
+    <repository>
+      <id>central</id>
+      <url>https://repo1.maven.org/maven2/</url>
+      <snapshots>
+        <enabled>false</enabled>
+      </snapshots>
+      <releases>
+        <enabled>true</enabled>
+      </releases>
+    </repository>
+    <repository>
+      <id>clojars</id>
+      <url>https://repo.clojars.org/</url>
+      <snapshots>
+        <enabled>true</enabled>
+      </snapshots>
+      <releases>
+        <enabled>true</enabled>
+      </releases>
+    </repository>
+  </repositories>
+  <dependencyManagement>
+    <dependencies/>
+  </dependencyManagement>
+  <dependencies>
+    <dependency>
+      <groupId>org.clojure</groupId>
+      <artifactId>clojure</artifactId>
+      <version>1.10.x</version>
+    </dependency>
+    <dependency>
+      <groupId>org.clojure</groupId>
+      <artifactId>tools.analyzer.jvm</artifactId>
+      <version>debian</version>
+    </dependency>
+  </dependencies>
+</project>
+
+<!-- This file was autogenerated by Leiningen.
+  Please do not edit it directly; instead edit project.clj and regenerate it.
+  It should not be considered canonical data. For more information see
+  https://github.com/technomancy/leiningen -->
diff -pruN 1.3.610-1/debian/rules 1.3.610-2/debian/rules
--- 1.3.610-1/debian/rules	2020-11-14 00:41:20.000000000 +0000
+++ 1.3.610-2/debian/rules	2020-12-07 17:32:17.000000000 +0000
@@ -1,24 +1,30 @@
 #!/usr/bin/make -f
 
+include /usr/share/dpkg/pkg-info.mk
 include /usr/share/javahelper/java-vars.mk
 
-PRODUCED_JAR=core.async.jar
-export CLASSPATH=/usr/share/java/clojure.jar:/usr/share/java/tools.analyzer.jvm.jar
+export LEIN_HOME=$(CURDIR)/.lein
+export LEIN_OFFLINE=true
+NAME=core.async
 
 %:
-	dh $@ --with javahelper,jh_maven_repo_helper
+	dh $@ --with javahelper --with maven_repo_helper
 
-override_jh_build:
-	jar cf $(PRODUCED_JAR) -C src/main/clojure .
+override_dh_auto_configure:
+	cd debian && ln -sf /usr/share/maven-repo .
 
-override_jh_clean:
-	jh_clean
-	rm -f $(CURDIR)/$(PRODUCED_JAR)
-
-override_jh_classpath:
-	jh_classpath $(PRODUCED_JAR)
+override_dh_auto_build:
+	lein jar
+	# symlink so we don't need a version in debian/*.poms
+	cd target && ln -sf $(NAME)-$(DEB_VERSION_UPSTREAM).jar $(NAME).jar
 
 override_dh_auto_test:
-	dh_auto_test
-	(cd src/test/clojure && find . -name '*.clj' | \
-		xargs clojure -cp $(CLASSPATH):$(CURDIR)/$(PRODUCED_JAR))
+	lein test
+
+override_jh_installlibs:
+	jh_installlibs target/$(NAME).jar
+
+override_dh_clean:
+	rm -f debian/maven-repo
+	rm -Rf target
+	dh_clean
diff -pruN 1.3.610-1/debian/tests/build 1.3.610-2/debian/tests/build
--- 1.3.610-1/debian/tests/build	2020-11-17 14:19:20.000000000 +0000
+++ 1.3.610-2/debian/tests/build	2020-12-08 22:47:41.000000000 +0000
@@ -1,5 +1,5 @@
 #!/bin/sh
 
-CLASSPATH=/usr/share/java/clojure.jar:/usr/share/java/tools.analyzer.jvm.jar:/usr/share/java/core.async.jar
+CLASSPATH=/usr/share/java/clojure.jar:/usr/share/java/tools.analyzer.jar:/usr/share/java/core.memoize.jar:/usr/share/java/tools.reader.jar:/usr/share/java/asm.jar:/usr/share/java/tools.analyzer.jvm.jar:/usr/share/java/core.async.jar
 
 clojure -cp $CLASSPATH -e '(use '"'"'clojure.core.async)'
diff -pruN 1.3.610-1/debian/tests/unittests 1.3.610-2/debian/tests/unittests
--- 1.3.610-1/debian/tests/unittests	2020-11-17 14:19:20.000000000 +0000
+++ 1.3.610-2/debian/tests/unittests	2020-12-08 22:50:37.000000000 +0000
@@ -1,7 +1,7 @@
 #!/bin/sh
 set -efu
 
-CLASSPATH=/usr/share/java/clojure.jar:/usr/share/java/tools.analyzer.jvm.jar:/usr/share/java/core.async.jar
+CLASSPATH=/usr/share/java/clojure.jar:/usr/share/java/tools.analyzer.jar:/usr/share/java/core.memoize.jar:/usr/share/java/tools.reader.jar:/usr/share/java/asm.jar:/usr/share/java/tools.analyzer.jvm.jar:/usr/share/java/core.async.jar
 
 cp -a src/test/clojure "$AUTOPKGTEST_TMP/test"
 cd "$AUTOPKGTEST_TMP"
